/******************************************************************************
 * fast_entity - fast html entity scanner algotithm in c                      *
 *                                                                            *
 * Author: Martijn van Oosterhout                                             *
 * Date: 25/04/00                                                             *
 * Last Modified: 01/05/00                                                    *
 ******************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

// For stpcpy
#define __USE_GNU
#include <string.h>

char *convert_entity( char *in, char *out )
{
//  printf("<%s>\n", in);
  if( !strcmp( in, "amp" ) )
    *out++ = '&';
  else if( !strcmp( in, "lt" ) )
    *out++ = '<';
  else if( !strcmp( in, "gt" ) )
    *out++ = '>';
  else
  {
    *out++ = '&';
    // stpcpy is not available on most platforms -- sjh 01/05/00
    // out = stpcpy( out, in );
    strcpy( out, in );
    out = out + strlen (out);
    *out++ = ';';
  }
  return out;
}

void replace_entities ( const char *in, char *out ) {
  while( *in )
  {
    if( in[0] != '&' )       // If no '&', just copy
      *out++ = *in++;
    else if( in[1] != '#' )  // Textual entity
    {
      char buffer[10];
      int i = 0;
      
      while( isalpha( in[i+1] ) && i < 9 )
      {
        buffer[i] = in[i+1];
        i++;
      }

      if( in[i+1] != ';' ) // No terminating ';'
      {
        i++;
        strncpy( out, in, i );  // Be careful not to copy any non-characters
        out += i;
        in += i;
      }
      else
      {
        buffer[i] = '\0';
      
        out = convert_entity( buffer, out );  // Converts, leaves unchanged if doesn't exist
        
        in += i+2;
      }
    }
    else
    {
      char *endptr;
      
      int num = strtoul( in+2, &endptr, 10 );   // Try to parse
      
      if( *endptr == ';' && num > 0 && num < 256 )  // If ended by ';' and valid number
      {
        *out++ = num;
        in = endptr+1;    // Store it
      }
      else
        *out++ = *in++;   // Skip the &
    }
  }
  *out = '\0';
}

int main()
{
  char b1[4096], b2[4096];
  
  while( fgets( b1, 4095, stdin ) )
  {
    replace_entities( b1, b2 );
    printf("%s", b2 );
  }
  return 0;
}
