/******************************************************************************
 * slow_entity - a test of the algorithm I used in the comp2100 a1 for        *
 *               character entities, to see if implementing in c will be      *
 *               fast, eiffel wasnt fast enough and yet the algorithm seems   *
 *               alright                                                      *
 *                                                                            *
 * Author: Steven Hanley                                                      *
 * Date: 24/04/00                                                             *
 * Last Modified: 26/04/00                                                    *
 ******************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>

char *mfgets(char *str, int size, FILE *stream) {

   char *ch;
   int len;

   ch = fgets (str, size, stream);
   len = strlen (str);
   if (str[len - 1] == '\n') { 
      str[len - 1] = '\0';   
      len--;
      if (str[len - 1] == '\r') str[len - 1] = '\0';
   }

   return ch;
}

/* out should be freed after finished with it */
char *replace_entities (char *in) {
   char *out, *target, *target_start, 
        *cstr; /* cstr is hte pointer to the string we are currently 
                  searching, this moves following the end of entities */
   int clen, i;

   clen = strlen (in);
   target_start = (char *) malloc (clen + 1);
   target = target_start;
   target[0] = '\0';
   cstr = in;
   for (cstr = in, i = 0; cstr < in + clen; i++) {
      char *start_entity, *cur_ch, entity_text[21], entity_val[21];
      int eti = 0, evi = 0;
      start_entity = index (cstr, (int) '&');
      cur_ch = start_entity;
      if (cur_ch == NULL) {
         strncat (target_start, cstr, strlen (cstr));
         break;
      } else if (cur_ch != cstr) {
         strncat (target_start, cstr, cur_ch-cstr);
      }

      /* adjust cur_ch for irelevant characters at the start of the entity */
      entity_text[eti] = '&'; eti++; cur_ch++;
      if (*cur_ch == '#') {
         entity_text[eti] = '#'; eti++; cur_ch++;
      }

      /* read the encoding for the entity */
      for (; *cur_ch != ';'; cur_ch++) {
         if (! isalnum ((int) *cur_ch)) break; /* this is not part of an entity */
         if (cur_ch >= clen + in) break; /* we ran out of bounds of the input string */
         if (eti > 19) break; /* no entities are larger than 20 characters, keep 
                                entity_text and entity_val bounded */
         entity_text[eti] = *cur_ch; eti++;
         entity_val[evi] = *cur_ch; evi++;
      }
      entity_val[evi] = '\0';
      if (*cur_ch == ';') {
         entity_text[eti] = ';'; eti++;
      }
      entity_text[eti] = '\0';

      /* entity_val now contains the string that can be translated 
         entity_text contains the original string including & # and ; 
         if it is part of the string */
      if ((*cur_ch == ';') && (strlen (entity_val) != 0)) {
         int c;
         c = (int) strtol (entity_val, NULL, 0); 
            /* no character based entities being tested yet */
         if ((c < 256) && (c > 0)) {
           *target++ = (char) c; *target = '\0';
         } else {
            strncat (target_start, entity_text, strlen (entity_text));
         }
      } else {
         strncat (target_start, entity_text, strlen (entity_text));
      }
      cstr = start_entity + strlen (entity_text); 
         /* ajust cstr to be further along in by the amount amount read */
   }

   out = strdup (target_start);
   free (target_start);
   return out;
}

int main () {
   char in[1024], *out;

   while (mfgets (in, 1024, stdin)) {
      out = replace_entities (in);
      printf ("%s\n", out);
      free (out);
   }

   return 0;
}
