/******************************************************************************
 * fast_entity - fast html entity scanner algotithm in java                   *
 *                                                                            *
 * Author: Martijn van Oosterhout                                             *
 * Date: 26/04/00                                                             *
 * Last Modified: 26/04/00                                                    *
 ******************************************************************************/

import java.io.*;

class fast_entity 
{

  String convert_entity( String ent )
  {
  //  printf("<%s>\n", in);
    if( ent.equals("amp") )
      return "&";
      
    if( ent.equals("lt") )
      return "<";
      
    if( ent.equals("gt") )
      return ">";
      
    return "&#" + ent + ";";
  }

  static String replace_entities ( String in ) {
    int inlen = in.length();
    
    byte[] ina = in.getBytes();
    byte[] outa = new byte[ inlen ];
    
    int inoff = 0;
    int outoff = 0;
    
    while( inoff < inlen )
    {
      if( ina[ inoff ] != '&' )    // If no '&', just copy
        outa[ outoff++ ] = ina[ inoff++ ];
      else if ( (inoff == inlen-1) || (ina[ inoff+1 ] != '#') )   // If textual entity or end of line
        outa[ outoff++ ] = ina[ inoff++ ];
      else
      {
        int num = 0;
        int off = inoff+2;
        
        while( off < inlen && Character.isDigit( (char)ina[ off ] ) )
        {
          num = (num*10) + Character.digit( (char)ina[ off ], 10 );
          off++;
        }
        
        if( off < inlen && ina[ off ] == ';' )
        {
          outa[ outoff++ ] = (byte)num;
          inoff = off+1;
        }
        else
        {
          outa[ outoff++ ] = ina[ inoff++ ];   // Skip if not valid....
        }
      }
    }
    return new String( outa, 0, outoff );
  }

  public static void main( String[] args ) throws IOException
  {
    BufferedReader in  = new BufferedReader( new InputStreamReader (System.in)  );
    PrintWriter out = new PrintWriter( new BufferedWriter( new OutputStreamWriter(System.out) ) );

    for(;;)
    {
      String s = in.readLine();
      
      if( s == null ) break;
          
      String o = replace_entities( s );
      
      out.println( o );
    }  
    out.flush();
  }

}
